#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#define MAXCH 150
#define MAXTAX 80
//++pac
#ifdef _PLAN9
#define RandInt(n) (rand()%(n))+1
#else
#define RandInt(n) (random()%(n))+1
#endif

/* PCPH Version 1.3.4 by John Alroy
  date of release: 1 September 1995
  Version 1.3.3: 1 September 1995
  Version 1.3.2: 19 March 1995
  Version 1.3.1: 18 March 1995
  Version 1.3: 18 March 1995
  Version 1.2: 17 March 1995
  Version 1.1.2: 15 March 1995
  Version 1.1.1: 14 March 1995
  Version 1.1: 2 July 1994
  new features: checks for all-binary matrices; ANSI standard usage,
   can be compiled using THINK C
  Version 1.0: 3 February 1994
  computes permutation-compatibility and permutation-hierarchy
   tests on character matrices
  input files must be in NEXUS format
  assumes that characters are ordered unless otherwise stated
  written from scratch 25-26.6.93
  revised to perform perm-nodal-compatibility and PN-hierarchy
   tests on all nodes in a tree 30.6.93
  revised to handle characters with > 10 states 11.12.93;
   assumes that letters represent these states
  line added 11.6.94 to guarantee trial results are output when
   nodal tests are NOT performed
  syntax improvements, output rearranged 14.5.95
  minor bug fixes, output revision 15.5.95
  split into two files for convenience of THINK C users 17.5.95
  code put back in a single file; "smart" interpretation of SYMBOLS string;
    ReadComment; character rows may include carriage returns 18.5.95
  "comp" changed to "compat"; long integers defined and printed explicitly
    18.5.95
  minor output bugs; RandInt() replaces rand() 19.5.95
  fine tuning of unordered character list inputting; bug caught in
    matrix input routine 1.9.95
  primitive state based on outgroup (=first taxon) instead of first
    symbol in symbol string 3.9.95  */

FILE *file1,*file2,*fopen();
long *clcomp,*clhier,*clmorecomp,*cleqcomp,*clmorehier,*cleqhier;
int *nest,*nstate;
char *ctype,*t,*t2;
char *mat[MAXTAX],*pmat[MAXTAX],*clades[MAXTAX];
char *tname[MAXTAX],*exist[MAXCH],*str,*tstr,*tstr2,*pstate,*scram;
int a,b,c,d;
int i,j,k,l;
char conj[10][10];
float fx,fy,fz,meancomp=0,meanhier=0;
long incomp=0,compat=0,hier=0,temp1=0,temp2=0,temp3=0,lx;
int x,y,ntax=0,nchar=0,nunord=0,nclade=0,nmiss=0;
int m,n,q,z=0,ao,tntax,tstate=0,trials,diag=0,ordtype,allbinary=1;
int morecomp=0,eqcomp=0,morehier=0,eqhier=0;
char ch,nostr[9],gapstr[9],symbstr[30];

void FillConj()	{
  if ((ctype[i]!=1)&(ctype[j]!=1))	{
    c=1;
    while (c>0)	{
      c=0;
      for (k=0;k<nstate[i];k++)	{
        a=-1; b=-1;
        for (l=0;l<nstate[j];l++)
          if (conj[k][l]==1) { b=l; if (a==-1) a=l; }
        if (a>-1) for (l=a;l<=b;l++) if (conj[k][l]==0) { conj[k][l]=1; c++; }
      }
      for (k=0;k<nstate[j];k++)	{
        a=-1; b=-1;
        for (l=0;l<nstate[i];l++)
          if (conj[l][k]==1) { b=l; if (a==-1) a=l; }
        if (a>-1) for (l=a;l<=b;l++) if (conj[l][k]==0) { conj[l][k]=1; c++; }
      }
    }
  }
}

void FillT()	{
  if (ctype[j]!=1)	{
    a=-1; b=-1;
    for (k=0;k<nstate[j];k++)
      if (t[k]==1) { b=k; if (a==-1) a=k; }
    if (a>-1) for (k=a;k<=b;k++) t[k]=1;
    a=-1; b=-1;
    for (k=0;k<nstate[j];k++)
      if (t2[k]==1) { b=k; if (a==-1) a=k; }
    if (a>-1) for (k=a;k<=b;k++) t2[k]=1;
  }
}

void ReadComment()	{

  if (strncmp(str,"[",1)==0)	{
    while (strchr(str,']')==0) fscanf(file1,"%s",str);
    fscanf(file1,"%s",str); ReadComment();
  }
}

void ReadNexus()	{
while (!feof(file1))	{
  fscanf(file1,"%s",str); ReadComment();
  if ((strncmp(str,"MISS",4)==0)||(strncmp(str,"miss",4)==0))
    sscanf(str,"%8s%s",tstr,&nostr);
  else if ((strncmp(str,"SYMBOLS",7)==0)||(strncmp(str,"symbols",7)==0)) {
    if (strlen(str)>10) sscanf(str,"%8s%s",tstr,&symbstr);
    else if (strlen(str)==7) fscanf(file1,"%s %s",str,symbstr);
    else printf("WARNING! Something is wrong with the SYMBOLS statement.\n");
  }
  else if ((strncmp(str,"GAP=",4)==0)||(strncmp(str,"gap=",4)==0))
    sscanf(str,"%4s%s",tstr,&gapstr);
  else if ((strncmp(str,"MATRIX",6)==0)||(strncmp(str,"matrix",6)==0))	{
    fscanf(file1,"%s",str); ReadComment();
    while (str[strlen(str)-1]!=59)	{
      ntax++; strcpy(tname[ntax],str);
      fscanf(file1,"%s",str); ReadComment(); strcpy(tstr,str); ao=1;
      while (ao==1)	{
        ao=0;
        fscanf(file1,"%s",str); ReadComment();
        for (i=0;i<strlen(symbstr);i++)
          if (symbstr[i]==str[0])	{
            strcat(tstr,str); ao=1;
            i=strlen(symbstr);
          }
      }
      if (ntax==1) nchar=strlen(tstr);
      for (i=0;i<strlen(tstr);i++)	{
        if ((tstr[i]==nostr[0])||(tstr[i]==gapstr[0]))	{
          mat[ntax][i]=-9; nmiss++;
        }
        else {
          for (j=0;j<strlen(symbstr);j++)
            if (tstr[i]==symbstr[j]) { x=j; j=strlen(symbstr); }
          mat[ntax][i]=x;
          if (x+1>nstate[i]) nstate[i]=x+1;
          exist[i][x]=1;
        }
      }
    }
  }
  else if ((strncmp(str,"ASSUMP",6)==0)||(strncmp(str,"assump",6)==0))
    while ((strcmp(str,"END;")!=0)&(strcmp(str,"end;")!=0))	{
      fscanf(file1,"%s",str); ReadComment();
      if ((strncmp(str,"unord:",6)==0)||(strncmp(str,"UNORD:",6)==0))	{
        if (strlen(str)<7)	{
          fscanf(file1,"%s",str); ReadComment();
        }
        else	{
          sscanf(str,"%6s%s",tstr2,tstr);
          strcpy(str,tstr);
        }
        while (atoi(str)>0)	{
          if (strlen(str)<3)	{
            sscanf(str,"%d",&x);
            ctype[x-1]=1;  nunord++;
          }
          else	{
            sscanf(str,"%d-%d",&i,&j);
            for (x=i;x<=j;x++)	{
              ctype[x-1]=1; nunord++;
            }
          }
          fscanf(file1,"%s",str); ReadComment();
        }
      }
    }
  else if ((strncmp(str,"TREES;",6)==0)||(strncmp(str,"trees;",6)==0))
    while(ch!=59)	{
      ch=getc(file1);
      if (ch==40)	{
        nest[1]++; a=0; b=0; c=0;
        while(ch!=59)	{
          if ((ch==39)||(ch==40)||(ch==41)||(ch==44)||(ch==59))
            if (b>0)	{
              if (atoi(str)>0) ao=atoi(str);
              else
                for (i=1;i<=ntax;i++)
                  if (strncmp(tname[i],str,strlen(tname[i]))==0)	{
                    ao=i; i=ntax;
                  } 
              c++; scram[c]=ao; nest[c]=a; b=0; strcpy(str,"");
            }
          if (ch==40) a++;
          else if (ch==41) {
            nclade++; d=0;
            for (i=c;i>0;i--)	{
              if (nest[i]==a)	{
                clades[scram[i]][nclade]=1; nest[i]--; d++;
              }
            }
            a--;
            if (d==ntax)	{
              for (i=1;i<=ntax;i++) clades[i][nclade]=0;
              nclade--;
            }
          }
          else if ((ch!=39)&(ch!=44))	{
            str[b+1]=str[b]; str[b]=ch; b++;
          }
          ch=getc(file1);
        }
      }
    }
}

}

main()	{

clcomp=(long*)calloc(MAXTAX,sizeof(long));
clhier=(long*)calloc(MAXTAX,sizeof(long));
clmorecomp=(long*)calloc(MAXTAX,sizeof(long));
cleqcomp=(long*)calloc(MAXTAX,sizeof(long));
clmorehier=(long*)calloc(MAXTAX,sizeof(long));
cleqhier=(long*)calloc(MAXTAX,sizeof(long));
nest=(int*)calloc(MAXTAX,sizeof(int));
nstate=(int*)calloc(MAXCH,sizeof(int));
ctype=(char*)calloc(MAXCH,sizeof(char));
t=(char*)calloc(MAXCH,sizeof(char));
t2=(char*)calloc(MAXCH,sizeof(char));
tstr=(char*)calloc(MAXCH,sizeof(char));
tstr2=(char*)calloc(MAXCH,sizeof(char));
str=(char*)calloc(MAXCH,sizeof(char));
pstate=(char*)calloc(MAXCH,sizeof(char));
scram=(char*)calloc(MAXTAX,sizeof(char));

for (i=0;i<MAXTAX;i++)
  mat[i]=(char*)calloc(MAXCH,sizeof(char));
for (i=0;i<MAXTAX;i++)
  pmat[i]=(char*)calloc(MAXCH,sizeof(char));
for (i=0;i<MAXTAX;i++)
  clades[i]=(char*)calloc(MAXTAX,sizeof(char));
for (i=0;i<MAXTAX;i++)
  tname[i]=(char*)calloc(80,sizeof(char));
for (i=0;i<MAXCH;i++)
  exist[i]=(char*)calloc(20,sizeof(char));

printf("\nPCPH Version 1.3.4 by John Alroy\n");
printf("Computes PC and PH tests (Alroy 1994, Systematic Biology 43(3))\n");
printf("Warning: PH test assumes first taxon is outgroup to assign polarities\n");
printf("\nInput NEXUS file: ");
scanf("%s",str);
file1=fopen(str,"r");
printf("Output file: ");
scanf("%s",str);
file2=fopen(str,"w");
printf("Number of permutation trials: ");
scanf("%d",&trials);

ReadNexus();

printf("\n%d taxa\n%d characters (%d ordered)\n",ntax,nchar,nchar-nunord);
printf("%d missing cell values\n",nmiss);
if (nclade>1) printf("%d clades\n",nclade);
else if (nclade==1) printf("Only one clade\n");
for (i=0;i<nchar;i++)
  if (nstate[i]>2) { allbinary=0; i=nchar; }
for (i=0;i<nchar;i++) {
  if (allbinary==1) nstate[i]--;
  x=nstate[i];
  for (j=nstate[i]-1;j>=0;j--)
    if (exist[i][j]!=1) x--;
  pstate[i]=mat[1][i];
  tstate=tstate+x;
  diag=diag+(((x*x)-x)/2);
}
printf("%d states, %d diagonal elements\n",tstate,diag);
lx=tstate;
printf("%ld possible compatible pairs\n",(((lx*lx)-lx)/2)-diag);
fflush(stdout);

for (i=1;i<nchar;i++)
  for (j=0;j<i;j++)	{
    for (k=0;k<nstate[i]+allbinary;k++)
      for (l=0;l<nstate[j]+allbinary;l++)
        conj[k][l]=0;
    for (k=1;k<=ntax;k++)
      if ((mat[k][i]>-1)&(mat[k][j]>-1))
        conj[mat[k][i]][mat[k][j]]=1;
    FillConj();
    for (k=0;k<nstate[i];k++)
     if (exist[i][k]==1)	{
      for (l=0;l<nstate[j];l++)
       if (exist[j][l]==1)	{
        ao=1;
        for (m=0;m<nstate[i]+allbinary;m++)
          for (n=0;n<nstate[j]+allbinary;n++)
           if ((conj[k][l]==1)&(conj[k][n]==1)&(conj[m][l]==1)&(conj[m][n]==1))
              if ((k!=m)&(l!=n))	{
                incomp++; ao=0; n=nstate[j]; m=nstate[i];
              }
        if (ao==1)	{
          if (allbinary==1) { k=1; l=1; }
          a=0; b=0; /* a=k/others; b=others/l */
          for (m=0;m<nstate[j]+allbinary;m++)
            if ((conj[k][m]==1)&(m!=l))	{
              a=1; m=nstate[j]+allbinary;
            }
          for (m=0;m<nstate[i]+allbinary;m++)
            if ((conj[l][m]==1)&(m!=k))	{
              b=1; m=nstate[i]+allbinary;
            }
          if ((k!=pstate[i])&(l!=pstate[j])&(conj[k][l]==1))
            hier++;
          else if ((k==pstate[i])&(l!=pstate[j])&(b==1))
            hier++;
          else if ((k!=pstate[i])&(l==pstate[j])&(a==1))
            hier++;
          else compat++;
        }
       }
     }
  }
printf("%ld incompatible, %ld compatible",incomp,compat+hier);
printf(", %ld hierarchical\n",hier);
for (i=1;i<=nclade;i++)
  for (j=0;j<nchar;j++)	{
    for (k=0;k<nstate[j];k++)
      { t[k]=0; t2[k]=0; }
    for (k=1;k<=ntax;k++)
      if (mat[k][j]>-1)	{
        if (clades[k][i]==0) t[mat[k][j]]=1;
        else t2[mat[k][j]]=1;
      }
    FillT();
    for (k=0;k<nstate[j];k++)
      if (exist[j][k]==1)	{
        a=0; b=t[k]; c=0; d=t2[k];
        for (l=0;l<nstate[j];l++)
          if ((t[l]==1)&(t2[l]==1)&(k!=l)) { a=1; c=1; l=nstate[j]; }
        if (allbinary==1) k=1;
        if ((b==0)&(k!=pstate[j])) clhier[i]++;
        if ((a==0)||(b==0)||(c==0)||(d==0)) clcomp[i]++;
      }
  }

for (z=1;z<=trials;z++)	{
for (i=0;i<nchar;i++)	{
  for (j=1;j<=ntax;j++)
    scram[j]=mat[j][i];
  tntax=ntax;
  while (tntax>=1)	{
    x=RandInt(tntax);
    pmat[tntax][i]=scram[x]; scram[x]=scram[tntax];
    tntax--;
  }
}

temp1=0; temp2=0; temp3=0;
for (i=1;i<nchar;i++)
  for (j=0;j<i;j++)	{
    for (k=0;k<nstate[i]+allbinary;k++)
      for (l=0;l<nstate[j]+allbinary;l++)
        conj[k][l]=0;
    for (k=1;k<=ntax;k++)
      if ((pmat[k][i]>-1)&(pmat[k][j]>-1))
        conj[pmat[k][i]][pmat[k][j]]=1;
    FillConj();
    for (k=0;k<nstate[i];k++)
     if (exist[i][k]==1)	{
      for (l=0;l<nstate[j];l++)
       if (exist[j][l]==1)	{
        ao=1;
        for (m=0;m<nstate[i]+allbinary;m++)
          for (n=0;n<nstate[j]+allbinary;n++)
           if ((conj[k][l]==1)&(conj[k][n]==1)&(conj[m][l]==1)&(conj[m][n]==1))
              if ((k!=m)&(l!=n))	{
                temp1++; ao=0; n=nstate[j]; m=nstate[i];
              }
        if (ao==1)	{
          if (allbinary==1) { k=1; l=1; }
          if ((conj[k][l]==1)&(k!=pstate[i])&(l!=pstate[j]))
            temp3++;
          else temp2++;
        }
       }
     }
  }
if (temp2+temp3>compat+hier) morecomp++;
else if ((temp2+temp3)==compat+hier) eqcomp++;
if (temp3>hier) morehier++; else if (temp3==hier) eqhier++;
meancomp=meancomp+temp2+temp3;
meanhier=meanhier+temp3;
if (nclade==0)
  fprintf(file2,"%ld %ld\n",temp2+temp3,temp3);

for (i=1;i<=nclade;i++)	{
  temp1=0; temp2=0; temp3=0;
  for (j=0;j<nchar;j++)	{
    for (k=0;k<nstate[j];k++)
      { t[k]=0; t2[k]=0; }
    for (k=1;k<=ntax;k++)
      if (pmat[k][j]>-1)	{
        if (clades[k][i]==0) t[pmat[k][j]]=1;
        else t2[pmat[k][j]]=1;
      }
    FillT();
    for (k=0;k<nstate[j];k++)
      if (exist[j][k]==1)	{
        a=0; b=t[k]; c=0; d=t2[k];
        for (l=0;l<nstate[j];l++)
          if ((t[l]==1)&(t2[l]==1)&(k!=l)) { a=1; c=1; l=nstate[j]; }
        if (allbinary==1) k=1;
        if ((a==1)&(b==1)&(c==1)&(d==1)) temp1++;
        else if ((b==0)&(k!=pstate[j])) temp3++;  else temp2++;
      }
  }
  if (temp2+temp3>clcomp[i]) clmorecomp[i]++;
  else if (temp2+temp3==clcomp[i]) cleqcomp[i]++;
  if (temp3>clhier[i]) clmorehier[i]++;
  else if (temp3==clhier[i]) cleqhier[i]++;
}
}
printf("\nPermuted matrices vs. real matrix:\n\n");
printf("Statistic\tmean\tN[>=]\tp[>=]\n");
fx=morecomp+eqcomp; fx=fx/trials;
printf("    C    \t%5.1f\t",meancomp/trials);
printf("%4d\t%5.3f\n",morecomp+eqcomp,fx);
fx=morehier+eqhier; fx=fx/trials;
printf("    H    \t%5.1f\t",meanhier/trials);
printf("%4d\t%5.3f\n",morehier+eqhier,fx);
for (i=1;i<=nclade;i++)	{
  fprintf(file2,"clade: ");
  a=0;
  for (j=1;j<=ntax;j++)
    if (clades[j][i]>0) { fprintf(file2,"%s ",tname[j]); a++; }
  b=1; if (a>(ntax-1)/2) a=ntax-a-1;
  for (j=ntax-1;j>=ntax-a;j--)
    b=b*j;
  for (j=1;j<=a;j++)
    b=b/j;
  fx=clmorecomp[i]; fy=cleqcomp[i];
  fx=fx/trials; fy=fy/trials;
  fprintf(file2,"\n%4ld compatible states;   ",clcomp[i]);
  fprintf(file2,"p = %-5.3f %-5.3f",fx+fy,(fx+fy)*b);
  fx=clmorehier[i]; fy=cleqhier[i];
  fx=fx/trials; fy=fy/trials;
  fprintf(file2,"\n%4ld hierarchical states; ",clhier[i]);
  fprintf(file2,"p = %-5.3f %-5.3f\n",fx+fy,(fx+fy)*b);
}
if (nclade==0)
  printf("\nRows in output file give C and H for each permutation.\n");
else	{
  printf("\nOutput file records a priori and a posteriori PC and PH\n");
  printf("  test results for each clade.\n");
}
printf("\n");
}


